#pragma once
#include "outfit.h"
#include "physics.h"

typedef enum { WEAPON_LAYER_BG, WEAPON_LAYER_FG } WeaponLayer;

void weapon_add(const Outfit* outfit, const double dir,
      const Vec2* pos, const Vec2* vel, unsigned int parent, WeaponLayer layer);

void weapons_update(const double dt, WeaponLayer layer);

void weapon_clear(void);
void weapon_exit(void);

